-- Another Laggy Evening (ALE)  2006 Rog. Please do not fork this for your own versions until it has completed beta.
-- http://gloomy.gameslate.com/
-- rogdor@gmail.com

-- Special thanks to Tom7 for his amazing fonts. All fonts added are  Tom7. http://fonts.tom7.com/
--[[
***************

"I'd rather have a bottle in front of me than a frontal lobotomy" - Dorothy Parker

***************

Version History:

v0.3beta (Sept 14, 2006)
	* First release version.
	* Created the concept of drunken moods for Lush + Roleplay mode:
		* Sad drunk, Scared drunk, Obnoxious drunk or Luvy Duvy drunk.
	* Added random occasional drinking songs for Lush + Roleplay mode.

v0.2beta (Sept 9, 2006)
	* Added triggers for queueing drinks in Lush mode:
		* Death
		* Pet Death
		* Hunter Feigns Death
		* NPC yells (IE: Eye of Naxxramas shouts "The living are here!")
		* Mob runs away.
		* Duel about to start.
		* Duel lost.
		* Spellcast fails due to lack of mana.
	* To-Do triggers:
		* Sheeped
		* Feared
		* MC'd
		* Aggro gain (if not a warrior or bear druid and you're in a party)

v0.1beta (Sept 7, 2006)
	*Sounds added.
	*Drinking in feral forms doesn't work, so "roleplay" drinks will be queue'd.
	*Drinks are also queue'd while in combat to avoid some odd targetting nuances.
	*Special "Lush" + "Roleplay" mode exists, but is incomplete.

v0.4alpha (Sept 4, 2006)
	*Drinking game basics added.

v0.03alpha (Aug 31, 2006):
	*Added options window with scaling and clear data.

v0.02alpha (Aug 30, 2006):
  	*Added the graph. Click the button to show/hide.

v0.01alpha (Aug 29, 2006):
  	*Just the basic lag meter button.

**************
--]]

function ALE_Initialize()
	local version = "v0.3beta";
	if (ALE_Cost == nil) then
		ALE_Cost = {};
		ALE_Cost.version = 0;
		ALE_Cost.lifetime = 0;
	end
	if (ALE_Settings == nil) then
		ALE_Settings = {};
		ALE_Settings.drinking = false;
		ALE_Settings.sounds = false;
		ALE_Settings.emotes = false;
		ALE_Settings.roleplay = false;
		ALE_Settings.verbose = false;
		ALE_Settings.threshold = 3;
	end
	if (ALE_Settings.version ~= version) then
		ALE_Settings.announce = nil; -- removed v0.1beta
		ALE_Cost.version = 0;
	end
	if (ALE_Settings.GraphScale == nil) then
		ALE_Settings.GraphScale = 100;
		ALE_Settings.GraphCenterx, ALE_Settings.GraphCentery = ALE_GraphWindow:GetCenter();
		ALE_GraphWindow:ClearAllPoints();
		ALE_GraphWindow:SetPoint("CENTER", "UIParent", "CENTER",0,0);
	end
	ALE_Cost.session = 0;
	ALE_RecordPings = {};
	ALE_Pings = {};
	ALE_Settings.version = version;
	if (ALE_Settings.Showing) then
		ALE_GraphWindow:Show();
		ALE_ResetGraph = 1;
	else
		ALE_GraphWindow:Hide();
		ALE_ResetGraph = 0;
	end
	DrinkPing = 0;GlobPing = 0;ALE_LastRLDrink = time() - 30;
	ALE_QueueDrink = 0;	ALE_TriggerLock = 0; ALE_Defcon = 0;ALE_DeathDetectDelay = 0; ALE_DrinkTime = time();
	ALE_CountBefore = 0; ALE_DrinkMsg = ""; ALE_DrinkCheck = 0; ALE_Singing = 0; ALE_Song = 0;
	ALE_Options_Initialize();
	SlashCmdList["ALEOPEN"] = ALE_CommandLine;
	SLASH_ALEOPEN1 = "/ale";
	if (ALE_Settings.GraphScale ~= 100) then
		Scalesize = ALE_Settings.GraphScale / 100;
		ALE_GraphWindow:ClearAllPoints();
		ALE_GraphWindow:SetPoint("CENTER", "UIParent", "BOTTOMLEFT",ALE_Settings.GraphCenterx / Scalesize, ALE_Settings.GraphCentery / Scalesize);
		ALE_GraphWindow:SetScale(Scalesize);
	end
	if (ALE_Settings.drinking and ALE_Settings.roleplay) then
		DEFAULT_CHAT_FRAME:AddMessage("|CFF00FF00ALE " .. ALE_Settings.version .. ":|CFFF1F1F1 loaded. Roleplay option on. Drinks available in your bags: " .. ALE_FindDrinks("links"));
	else
		DEFAULT_CHAT_FRAME:AddMessage("|CFF00FF00ALE " .. ALE_Settings.version .. ":|CFFF1F1F1 loaded.");
	end
	if (ALE_Settings.threshold >= 4) then
		table.sort(ALE_DRINK_LIST, ALE_sortfunc_SortPotency);
		ALE_Verbose("Sorting drinks by potency...");
	else
		table.sort(ALE_DRINK_LIST, ALE_sortfunc_SortValue);
		ALE_Verbose("Sorting drinks by value...");
	end
end

function ALE_MiniButton_OnClick()
	if (arg1=="LeftButton") then
		if (ALE_GraphWindow:IsVisible()) then
			ALE_GraphWindow:Hide();
			ALE_Settings.Showing = false;
		else
			ALE_GraphWindow:Show();
			ALE_Settings.Showing = true;
			ALE_ResetGraph = 1;
			ALE_PingReport();
		end
	else
		ALE_Options_Toggle()
	end
end

function ALE_GraphWindow_OnClick()
	if (arg1=="LeftButton") then
		ALE_PingReport();
	else
		ALE_Options_Toggle()
	end
end

function ALE_CommandLine(arg)
	if (arg ~= nil and (arg == "drinklist" or arg == "drinks")) then
		ALE_DrinkList("all");
	elseif (arg == "drunk") then
		ALE_Verbose("Adding 20 drinks (max) to the queue.");
		ALE_QueueDrink = 20;
	else
		ALE_GraphWindow:Show();
		ALE_Settings.Showing = true;
		ALE_ResetGraph = 1;
		ALE_PingReport();
		ALE_OptionsWindow:Show();
		ALE_DrinkList();
	end
end

function ALE_PingReport(arg)
	local DownStream, UpStream, Ping = GetNetStats();
	local pingText;
	if (Ping > PERFORMANCEBAR_MEDIUM_LATENCY) then
		pingText = "Ping |CFFFF0000" .. Ping .. "ms";
	elseif (Ping > PERFORMANCEBAR_LOW_LATENCY) then
		pingText = "Ping |CFFFFCC00" .. Ping .. "ms";
	else
		pingText = "Ping |CFF00FF00" .. Ping .. "ms";
	end
	if (getn(ALE_Pings) > 1 and ALE_Settings.drinking and ALE_Settings.verbose) then
		local oldPing = ALE_Pings[getn(ALE_Pings)-1].ping;
		local changePing = Ping - oldPing;
		if (oldPing > PERFORMANCEBAR_MEDIUM_LATENCY) then
			pingText = pingText .. "|CFFF1F1F1, previous ping |CFFFF0000" .. oldPing .. "ms|CFFF1F1F1 (Change: " .. changePing ..")";
		elseif (oldPing > PERFORMANCEBAR_LOW_LATENCY) then
			pingText = pingText .. "|CFFF1F1F1, previous ping |CFFFFCC00" .. oldPing .. "ms|CFFF1F1F1 (Change: " .. changePing ..")";
		else
			pingText = pingText .. "|CFFF1F1F1, previous ping |CFF00FF00" .. oldPing .. "ms|CFFF1F1F1 (Change: " .. changePing ..")";
		end
		ALE_Verbose(pingText);
	elseif (arg ~= nil and arg == "verbose") then
		ALE_Verbose(pingText);
	else
		ALE_Message(pingText);
	end
end

function ALE_OnUpdate(elapsed)
	local GraphTexture;
	if (ALE_ResetGraph ~= nil and ALE_ResetGraph >= 1) then
-- Do the fancy init display of the graph.
		if (ALE_ResetGraph <= 5) then
			for i = 1, 49, 1 do
				GraphTexture = getglobal("ALE_Graphbar"..i);
				GraphTexture:SetHeight(math.random(20 * ALE_ResetGraph));
			end
			ALE_ResetGraph = ALE_ResetGraph + 1;
		elseif (ALE_ResetGraph <= 8) then
			for i = 1, 49, 1 do
				GraphTexture = getglobal("ALE_Graphbar"..i);
				GraphTexture:SetHeight(math.random(60));
			end
			ALE_ResetGraph = ALE_ResetGraph + 1;
		elseif (ALE_ResetGraph <= 10) then
			for i = 1, 49, 1 do
				GraphTexture = getglobal("ALE_Graphbar"..i);
				GraphTexture:SetHeight(math.random(20));
			end
			ALE_ResetGraph = ALE_ResetGraph + 1;
		elseif (ALE_ResetGraph <= 12) then
			for i = 1, 49, 1 do
				GraphTexture = getglobal("ALE_Graphbar"..i);
				GraphTexture:SetHeight(1);
			end
			ALE_ResetGraph = ALE_ResetGraph + 1;
		elseif (ALE_ResetGraph == 14) then
			ALE_DrawGraph();
			ALE_ResetGraph = ALE_ResetGraph + 1;
		elseif (ALE_ResetGraph <= 100) then
			ALE_ResetGraph = ALE_ResetGraph + 1;
		else
			ALE_ResetGraph = 0;
			ALE_LogoText:SetText("ALE");
		end
	end
	if (this.clocktick == nil) then
		this.clocktick = 0;
	end
	this.clocktick = this.clocktick + elapsed;
	if (this.clocktick > 0.6 and ALE_Pings ~= nil) then
		this.clocktick = 0;
		math.randomseed(math.random(0,2147483647)+(GetTime()*1011));
		local DownStream, UpStream, Ping = GetNetStats();
		GlobPing = Ping;
		if (GlobPing > PERFORMANCEBAR_MEDIUM_LATENCY) then
			ALE_MiniMap_Button:SetNormalTexture("Interface\\AddOns\\AnotherLaggyEvening\\gfx\\MiniMapButton_Red.tga");
		elseif (GlobPing > PERFORMANCEBAR_LOW_LATENCY) then
			ALE_MiniMap_Button:SetNormalTexture("Interface\\AddOns\\AnotherLaggyEvening\\gfx\\MiniMapButton_Yellow.tga");
		else
			ALE_MiniMap_Button:SetNormalTexture("Interface\\AddOns\\AnotherLaggyEvening\\gfx\\MiniMapButton_Green.tga");
		end
		local PingNum;local changePing = 0;
		if (getn(ALE_Pings) == nil or getn(ALE_Pings) < 1) then
			PingNum = 1;
			ALE_Pings[PingNum] = {ping = GlobPing, timestamp = time(), change = 0};
		elseif (getn(ALE_Pings) >= 49) then
			PingNum = 49;
			if (GlobPing ~= ALE_Pings[PingNum].ping or time() > (ALE_Pings[PingNum].timestamp + 30)) then
				table.sort(ALE_Pings, ALE_sortfunc_SortTime);
				changePing = GlobPing - ALE_Pings[49].ping;
				ALE_Pings[1] = {ping = GlobPing, timestamp = time(), change = changePing};
				ALE_PingDrink(GlobPing,changePing);
				table.sort(ALE_Pings, ALE_sortfunc_SortTime);
			else
				ALE_NoRepeat = false;
			end
		else
			changePing = GlobPing - ALE_Pings[getn(ALE_Pings)].ping;
			PingNum = getn(ALE_Pings) + 1;
			if (GlobPing ~= ALE_Pings[PingNum - 1].ping or time() > (ALE_Pings[PingNum - 1].timestamp + 30)) then
				ALE_Pings[PingNum] = {ping = GlobPing, timestamp = time(), change = changePing};
				ALE_PingDrink(GlobPing,changePing);
			end
		end
		ALE_DrawGraph();
		if (ALE_Settings.drinking) then
			ALE_DrinkElapsed();
			local rand = math.random(750);
			if (ALE_Singing >= 1) then
				ALE_Sing();
			else
				if (ALE_Settings.roleplay and ALE_Settings.threshold == 5 and ALE_Defcon >= 2 and rand == 229) then
					ALE_Singing = 1;
				elseif (ALE_Settings.emotes and ALE_Settings.roleplay and ALE_Settings.threshold == 5 and ALE_Defcon >= 2 and (rand == 68 or rand == 270 or rand == 445 or rand == 612 or rand == 737)) then
					ALE_Emote("lush");
				end
			end
			if (ALE_Settings.roleplay) then
				if (ALE_DrinkMsg ~= "") then
					if (ALE_DrinkCheck == 1) then
						ALE_DrinkCheck = 2;
					else
						ALE_DrinkAlert();
						ALE_DrinkCheck = 0;
					end
				end
			else
-- Don't wait on event to drink if roleplay mode is off
				ALE_TriggerDrink();
			end
			if (ALE_Settings.roleplay and ALE_Settings.threshold == 5 and ALE_LushEvent ~= nil and ALE_LushEvent ~= "") then
				ALE_LushSpecialEvents();
			elseif (ALE_LushEvent ~= nil and ALE_LushEvent ~= "") then
				ALE_LushEvent = "";
			end
		end
	end
	if (ALE_TriggerLock == 2) then
		ALE_TriggerLock = 3;
	elseif (ALE_TriggerLock == 3) then
		ALE_TriggerLock = 0;
	end
end

function ALE_DrawGraph()
	local PingHeight; local Ping; local Bright;
	for i = 1, getn(ALE_Pings), 1 do
		Ping = ALE_Pings[i].ping;
		PingHeight = math.floor(ALE_Pings[i].ping / 12);
		GraphTexture = getglobal("ALE_Graphbar"..i);
		if (i == getn(ALE_Pings)) then
			Bright = 1;
			GraphTexture:SetWidth(4);
		else
			Bright = 0.6;
			GraphTexture:SetWidth(3);
		end
		if (Ping >600) then
			if (PingHeight >= 100) then
				PingHeight = 100;
			end
			GraphTexture:SetVertexColor(Bright,0,0,1);
			GraphTexture:SetHeight(PingHeight);
		elseif(Ping > 300) then
			GraphTexture:SetVertexColor(Bright,Bright,0,1);
			GraphTexture:SetHeight(PingHeight);
		else
			GraphTexture:SetVertexColor(0,Bright,0,1);
			GraphTexture:SetHeight(PingHeight);
		end
	end
end

function ALE_sortfunc_SortTime(a, b)
	return a.timestamp < b.timestamp;
end

function ALE_sortfunc_SortValue(a, b)
	return a.sortvalue < b.sortvalue;
end

function ALE_sortfunc_SortPotency(a, b)
	return a.sortpotency < b.sortpotency;
end

function ALE_VEmote(token,target)
	if (token ~= nil and token ~= "" and ALE_Settings.emotes) then
		if (target ~= nil and target ~= "") then
			DoEmote(token,target);
		end
	end
end

function ALE_Emote(msg)
	if (msg ~= nil and msg ~= "" and ALE_Settings.emotes) then
		SendChatMessage(msg, "EMOTE");
	end
end

function ALE_Verbose(msg)
	if (msg ~= nil and msg ~= "" and ALE_Settings.verbose) then
		ALE_Message(msg);
	end
end

function ALE_Message(msg)
	if (msg ~= nil and msg ~= "") then
		DEFAULT_CHAT_FRAME:AddMessage("|CFF55FF00ALE:|CFFF1F1F1 " .. msg);
	end
end

function ALE_ShowTooltip(pos)
	ALE_LogoText:SetText("Drink!");
	ALE_ResetGraph = 1;
	local DownStream, UpStream, Ping = GetNetStats();
	if (Ping > PERFORMANCEBAR_MEDIUM_LATENCY) then
		PingText = "|CFFFF0000" .. Ping .. "ms";
	elseif (Ping > PERFORMANCEBAR_LOW_LATENCY) then
		PingText = "|CFFFFCC00" .. Ping .. "ms";
	else
		PingText = "|CFF00FF00" .. Ping .. "ms";
	end
	ALE_Tooltip:SetOwner(this, pos);
	ALE_Tooltip:SetText(PingText);
end

function ALE_HideTooltip()
	ALE_Tooltip:SetOwner(this, pos);
	ALE_Tooltip:SetText("");
end
