

-- Got my drink list via Allakhazam, searched for items with the inebriate effect.
-- Egg Nog was taken off the list because it's a sit-down drink. Volatile Rum removed in case player needs it.
-- Drink priority is based upon the drink threshold:
--	* At "Casual Drinker", "Wearing Beerglasses" & "Shotgunning" priority is on cheaper vendor drinks.
--	* At "Squeanhead" and "Lush" priority is on potent drinks. Exception is Cherry Grog which gets a
--	  higher priority due to its 1 sec (instead of 10 sec) global drink cooldown.
if (ALE_DRINK_LIST == nil) then
ALE_DRINK_LIST = {
	{ drink = "Cheap Beer", value = 0.1, source = "vendor", sortvalue = 1, sortpotency = 18 },
	{ drink = "Moonglow", value = 0.15, source = "vendor", sortvalue = 2, sortpotency = 23 },
	{ drink = "Bottle of Pinot Noir", value = 0.5, source = "vendor", sortvalue = 3, sortpotency = 19 },
	{ drink = "Thunder Ale", value = 0.5, source = "vendor", sortvalue = 4, sortpotency = 20 },
	{ drink = "Rhapsody Malt", value = 0.5, source = "vendor", sortvalue = 5, sortpotency = 21 },
	{ drink = "Darkmoon Special Reserve", value = 0.5, source = "vendor", sortvalue = 6, sortpotency = 1 },
	{ drink = "Holiday Spirits", value = 0.5, source = "vendor", sortvalue = 7, sortpotency = 22 },
	{ drink = "Skin of Dwarven Stout", value = 1.2, source = "vendor", sortvalue = 8, sortpotency = 12 },
	{ drink = "Southshore Stout", value = 1.45, source = "vendor", sortvalue = 9, sortpotency = 13 },
	{ drink = "Flask of Port", value = 1.5, source = "vendor", sortvalue = 10, sortpotency = 14 },
	{ drink = "Junglevine Wine", value = 3, source = "vendor", sortvalue = 11, sortpotency = 6 },
	{ drink = "Cherry Grog", value = 3.4, source = "vendor", sortvalue = 12, sortpotency = 2 },
	{ drink = "Flagon of Mead", value = 15, source = "vendor", sortvalue = 13, sortpotency = 7 },
	{ drink = "Jug of Bourbon", value = 20, source = "vendor", sortvalue = 14, sortpotency = 8 },
	{ drink = "Filled Festive Mug", value = 0, source = "other", sortvalue = 15, sortpotency = 24 },
	{ drink = "Wizbang's Special Brew", value = 1.2, source = "quest", sortvalue = 16, sortpotency = 15 },
	{ drink = "Keg of Thunderbrew Lager", value = 4.45, source = "quest", sortvalue = 17, sortpotency = 5 },
	{ drink = "Dark Dwarven Lager", value = 10, source = "quest", sortvalue = 18, sortpotency = 3 },
	{ drink = "Steamwheedle Fizzy Spirits", value = 1.5, source = "drop", sortvalue = 19, sortpotency = 16 },
	{ drink = "Evermurky", value = 2, source = "drop", sortvalue = 20, sortpotency = 17 },
	{ drink = "Molasses Firewater", value = 10, source = "drop", sortvalue = 21, sortpotency = 9 },
	{ drink = "Cuergo's Gold", value = 16, source = "drop", sortvalue = 22, sortpotency = 10 },
	{ drink = "Cuergo's Gold with Worm", value = 16, source = "drop", sortvalue = 23, sortpotency = 4 },
	{ drink = "Greatfather's Winter Ale", value = 20, source = "drop", sortvalue = 24, sortpotency = 11 },
	{ drink = "Toasting Goblet", value = 0, source = "drop", sortvalue = 25, sortpotency = 25 },
};
end

if (ALE_DRINK_SONGS == nil) then
ALE_DRINK_SONGS = {
	{ song = "Heave Away", line1 = "Steamwheedle Port aint got no sleds", line2 = "Heave away, heave away", line3 = "They slide down hills on codfish heads", line4 = "Heave away me bonny bonny boys!" },
	{ song = "Swing Low", line1 = "I looked over Elwynn and what did I see?", line2 = "Coming for to carry me home", line3 = "A band of Murlocs coming after me", line4 = "Coming for to carry me home!" },
	{ song = "Lukee's Boat", line1 = "Lukee's boat is painted green", line2 = "Aha, me boys, a riddle I day", line3 = "Prettiest boat I ever did see", line4 = "Aha, me boys, a riddle I day!" },
	{ song = "Drunken Sailor", line1 = "What shall we do with a drunk Forsaken?", line2 = "Early in the morning", line3 = "Way, hay, up she rises", line4 = "Early in the morning!" },
	{ song = "Scurvy", line1 = "Thar's scurvy on a pirate ship", line2 = "It'll rot your bones so here's a tip:", line3 = "When thar's scurvy on a pirate ship", line4 = "Eat a lime, eat a lime!" },
	{ song = "Hieland Laddie", line1 = "Was you ever in Ogremart?", line2 = "Bonny laddie, Hieland laddie", line3 = "Was you ever in Tauren Mill?", line4 = "Hey, ho and and away we go, bonnie Hieland laddie-O!" },
	{ song = "Irish Rover", line1 = "We had one million bags of the best Ogre rags", line2 = "We had two million barrels of volatile rum", line3 = "We had three million pigs and four million sheep", line4 = "In the hold of the Irish Rover!" },
	{ song = "Wild Rover", line1 = "I've been a wild rover for many a year", line2 = "I've spent all my money on whiskey and beer", line3 = "Now I'll save all my drops, keep money in store", line4 = "And never will play the wild rover no more!" },
	{ song = "Mari Mack", line1 = "There's a neat little lass and her name is Mari-Mac", line2 = "And make no mistake she's a girl I'm gonna track", line3 = "Lot's of those fellas tryin' to get her on her back", line4 = "But I'm thinkin' they'll have to get up early!" },
	{ song = "Mari Mack", line1 = "Mari-Mac's mother's makin' Mari-Mac marry me", line2 = "My mother's makin' me marry Mari-Mac", line3 = "Well I'm gonna marry Mari for when Mari's takin' care of me", line4 = "We'll all be feelin' merry when I marry Mari-Mac!" },
};
end

function ALE_TriggerDrink()
-- Drink Queue. Triggered by changing targets which is a workaround but our addon is pretty harmless as far as automation goes.
	if (ALE_TriggerLock == 0) then
		ALE_TriggerLock = 1;
		if (ALE_QueueDrink >= 1) then
			local drinkCheck;
			if (ALE_Settings.drinking and ALE_Settings.roleplay) then
				ALE_CountBefore = ALE_FindDrinks("count");
				drinkCheck = ALE_FindDrinks("drink");
				if (drinkCheck ~= "delayed") then
					ALE_DrinkMsg = drinkCheck;
					ALE_DrinkCheck = 1;
				end
			elseif (ALE_Settings.drinking) then
				drinkCheck = ALE_DrinkRLDelay();
				if (drinkCheck ~= "delayed") then
--					ALE_QueueDrink = ALE_QueueDrink - 1;
					ALE_DrinkAlert();
				end
			else
				ALE_QueueDrink = 0; -- We're not drinking at all, so kill the queue.
			end
		end
		ALE_TriggerLock = 2;
	end
end

function ALE_DrinkRLDelay()
	local drinkOk;
	if (ALE_LastRLDrink < time() - 45) then
		drinkOk = "";
		ALE_LastRLDrink = time();
	else
		drinkOk = "delayed";
	end
	return drinkOk;
end

function ALE_DrinkSound()
	local randomSound = ""; local rand = 0;
	if (ALE_Settings.sounds) then
		math.randomseed(math.random(0,2147483647)+(GetTime()*1000));
		if (ALE_Settings.roleplay and ALE_OutOfDrinks) then
			rand = math.random(3);
-- Clips of "How Dry I Am" variations by: Epicenter, Herschell Gordon Lewis and Earth.
			randomSound = "Interface\\AddOns\\AnotherLaggyEvening\\sounds\\how_dry_" .. rand .. ".mp3";
			ALE_OutOfDrinks = false;
		else
			rand = math.random(6);
			randomSound = "Interface\\AddOns\\AnotherLaggyEvening\\sounds\\drink" .. rand .. ".wav";
		end
		PlaySoundFile(randomSound);
	end
end

function ALE_PingDrink(ping,change)
	if (ALE_Settings.drinking and ALE_QueueDrink < 20 and ping > change and ping - change > 0) then
		local multiplyChange; local triggerChange; local addThisTotal = 0;local outText = "";
		if (ALE_Settings.threshold == 5) then
			triggerChange = 40;
		elseif (ALE_Settings.threshold == 4) then
			triggerChange = 60;
		elseif (ALE_Settings.threshold == 3) then
			triggerChange = 100;
		elseif (ALE_Settings.threshold == 2) then
			triggerChange = 200;
		else
			triggerChange = 300;
		end
		if (change >= triggerChange) then
			addThisTotal = addThisTotal + 1;
		end
		if (ALE_Settings.threshold >= 4) then
-- Higher drinking modes add multiple drinks for big spikes.
			multiplyChange = math.floor(change / triggerChange) - 1;
			if (multiplyChange >= 1) then
				addThisTotal = addThisTotal + multiplyChange;
				outText = outText .. "+" .. multiplyChange .. " Multiplyer. ";
			end
		end
		if (ALE_Settings.threshold == 5) then
-- Lush mode gets extra drinks for various thresholds crossed.
			if (ping > 2000 and ping - change < 2000) or
			(ping > 1900 and ping - change < 1900) or
			(ping > 1800 and ping - change < 1800) or
			(ping > 1700 and ping - change < 1700) or
			(ping > 1600 and ping - change < 1600) or
			(ping > 1500 and ping - change < 1500) or
			(ping > 1400 and ping - change < 1400) or
			(ping > 1300 and ping - change < 1300) or
			(ping > 1200 and ping - change < 1200) or
			(ping > 1100 and ping - change < 1100) or
			(ping > 1000 and ping - change < 1000) or
			(ping > 900 and ping - change < 900) or
			(ping > 800 and ping - change < 800) or
			(ping > 700 and ping - change < 700) or
			(ping > 600 and ping - change < 600) or
			(ping > 500 and ping - change < 500) or
			(ping > 400 and ping - change < 400) or
			(ping > 300 and ping - change < 300) or
			(ping > 200 and ping - change < 200) or
			(ping > 100 and ping - change < 100) or
			(ping > 60 and ping - change < 60) then
				addThisTotal = addThisTotal + 1;
				outText = outText .. "Threshold crossed. ";
			end
		elseif (ALE_Settings.threshold == 4) then
-- A couple of thresholds for Squeanhead mode too.
			if (ping > 2000 and ping - change < 2000) or
			(ping > 1600 and ping - change < 1600) or
			(ping > 1200 and ping - change < 1200) or
			(ping > 1000 and ping - change < 1000) or
			(ping > 800 and ping - change < 800) or
			(ping > 400 and ping - change < 400) or
			(ping > 100 and ping - change < 100) then
				addThisTotal = addThisTotal + 1;
				outText = outText .. "Threshold crossed. ";
			end
		end
		if (ALE_Settings.threshold >= 3) then
-- Add a drink if jumped from green to yellow or yellow to red.
			if (ping > PERFORMANCEBAR_MEDIUM_LATENCY) then
				if ((ping - change) < PERFORMANCEBAR_LOW_LATENCY) then
					addThisTotal = addThisTotal + 2;
					outText = outText .. "|CFF00FF00Green|CFFF1F1F1 to |CFFFF0000Red|CFFF1F1F1. Ouch, big spike! ";
				elseif ((ping - change) < PERFORMANCEBAR_MEDIUM_LATENCY) then
					addThisTotal = addThisTotal + 1;
					outText = outText .. "|CFFFFCC00Yellow|CFFF1F1F1 to |CFFFF0000Red|CFFF1F1F1. ";
				end
			elseif (ping > PERFORMANCEBAR_LOW_LATENCY) then
				if ((ping - change) < PERFORMANCEBAR_LOW_LATENCY) then
					addThisTotal = addThisTotal + 1;
					outText = outText .. "|CFF00FF00Green|CFFF1F1F1 to |CFFFFCC00Yellow|CFFF1F1F1. ";
				end
			end
		end
		if (addThisTotal > 0) then
			ALE_PingReport("verbose");
			if (ALE_QueueDrink + addThisTotal > 20) then
				ALE_QueueDrink = 20;
				ALE_Verbose(outText .. "Queue maxed to 20 drinks due to ping change.");
			else
				ALE_QueueDrink = ALE_QueueDrink + addThisTotal;
				if (addThisTotal == 1) then
					ALE_Verbose(outText .. "Added 1 drink to the queue due to ping change.");
				else
					ALE_Verbose(outText .. "Added " .. addThisTotal .. " drinks to the queue due to ping change.");
				end
			end
		end
	end
end

function ALE_DrinkAlert()
-- Our text, graph and sound alerts that it's time to take a drink. 
	local continue = true;
	if (ALE_Settings.roleplay) then
		local countAfter = ALE_FindDrinks("count");
		if (countAfter < ALE_CountBefore or ALE_CountBefore == 0) then
			ALE_LushEvent = "DrinkConfirmed";
			if (ALE_QueueDrink <= 2) then
				ALE_Verbose(ALE_DrinkMsg .. " (1 more drink in queue)");
			elseif (ALE_QueueDrink > 2) then
				ALE_Verbose(ALE_DrinkMsg .. " (" .. ALE_QueueDrink - 1 .. " more drinks in queue)");
			else
				ALE_Verbose(ALE_DrinkMsg);
			end
		else
			continue = false;
		end
		ALE_DrinkMsg = "";
	end
	if (continue) then
		ALE_Emote("drink");
		ALE_DrinkSound();
		if (ALE_Settings.roleplay) then
			if (not ALE_Settings.verbose) then
				ALE_Message("Drinking...");
			end
		else
			ALE_Message("Take a drink.");
		end
		ALE_LogoText:SetText("Drink!");
		if (ALE_ResetGraph < 1) then
			ALE_ResetGraph = 1;
		end
		ALE_QueueDrink = ALE_QueueDrink - 1;
		ALE_DrinkTime = time();
	end
end

function ALE_DrinkList(arg)
	if (arg == "all") then
		local drinklist = "";
		ALE_Message("Full list of drinks ALE supports:");
		for i=1, table.getn(ALE_DRINK_LIST), 1 do
			if (i == 1) then
				drinklist = ALE_DRINK_LIST[i].drink;
			else
				drinklist = drinklist .. ", " .. ALE_DRINK_LIST[i].drink;
			end
		end
		DEFAULT_CHAT_FRAME:AddMessage(drinklist .. ".");
	else
		ALE_Message("For a full list of drinks ALE may make you drink, type /ale drinklist");
		ALE_Message("Drinks found in your bags: " .. ALE_FindDrinks("links"));
	end
end

function ALE_FindDrinks(arg)
	local drinklist = 0; local drinkhalt = true; local notList = true;
	for i=1, table.getn(ALE_DRINK_LIST), 1 do
		notList = true;
		for bag=0,4 do
			for slot=1,GetContainerNumSlots(bag) do
				itemLink = GetContainerItemLink(bag,slot)
				if (itemLink) then
-- Item name extraction borrowed from TrinketMenu. I was never any good at regex/parsing/etc..
					_,_,itemID,itemName = string.find(GetContainerItemLink(bag,slot) or "","item:(%d+).+%[(.+)%]")
					if (string.find(itemName, ALE_DRINK_LIST[i].drink)) then
						if (arg == "links") then
							if (drinklist == 0) then
								drinklist = "";
							end
							if (notList) then
								drinklist = drinklist .. " " .. itemLink;
								notList = false;
							end
						elseif (arg == "text") then
							if (i == 1) then
								drinklist = itemName;
							else
								drinklist = drinklist .. ", " .. itemName;
							end
						elseif (arg == "count") then
							local _,itemCount,_,_,_ = GetContainerItemInfo(bag,slot);
							drinklist = drinklist + itemCount;
						elseif (arg == "drink" and drinkhalt) then
							cooldownCheck, _, _ = GetContainerItemCooldown(bag,slot);
							if (BankFrame:IsVisible() or MerchantFrame:IsVisible() or cooldownCheck > 0 or UnitOnTaxi("player") or CursorHasItem() or CursorHasSpell() or SpellIsTargeting() or UnitIsDeadOrGhost("player") or UnitAffectingCombat("player") or ALE_isMounted() or ALE_checkDruid()) then
								drinklist = "delayed";
							else
								UseContainerItem(bag,slot);
								ALE_AddCost(ALE_DRINK_LIST[i].value);
								drinklist = "Drinking " .. itemLink;
							end
							drinkhalt = false;
						end
					end
				end
			end
		end
	end
	if (arg == "drink" and drinkhalt) then
		drinklist = "No drinks found. Stock up on bevvies!";
		ALE_OutOfDrinks = true;
	elseif (drinklist == 0 and arg ~= "count") then
		drinklist = "none";
	end
	return drinklist;
end

function ALE_AddCost(amount)
	ALE_Cost.session = ALE_Cost.session + amount;
	ALE_Cost.version = ALE_Cost.version + amount;
	ALE_Cost.lifetime = ALE_Cost.lifetime + amount;
end

function ALE_isMounted()
	local findmount = false; local text;
	for j = 0, 15 do
		ALE_ScanTooltip:SetPlayerBuff(GetPlayerBuff(j, "HELPFUL"));
		text = ALE_ScanTooltipTextLeft2:GetText();
		if (text ~= nil and string.find(text, "ncreases speed by")) then
			findmount = true;
		end
		ALE_ScanTooltip:ClearLines()
	end
	return findmount;
end

function ALE_LushBuyDrinks()
-- Randomly purchase drinks, but only if we have at least 5g
	local randAgainst = 250;
	math.randomseed(math.random(0,2147483647)+(GetTime()*1000));
	if (ALE_Defcon > 1) then
		randAgainst = 160; -- Odds go up if drunk.
	end
	if (GetMoney() >= 50000 and math.random(randAgainst) < 100) then
		local areWeBuying = true;local drinkTotal;
		drinkTotal = ALE_FindDrinks("count") + 0;
		ALE_Verbose("You have " .. drinkTotal .. " drinks in your bags.");
-- if we have 40 or more drinks in our bags already, don't bother buying.
		if (drinkTotal <= 39) then
			for i=1, table.getn(ALE_DRINK_LIST), 1 do
				for merch=1,GetMerchantNumItems() do
					local itemString = GetMerchantItemInfo(merch);
					if (itemString == ALE_DRINK_LIST[i].drink) then
						if (UnitLevel("player") <= 24 and ALE_DRINK_LIST[i].drink == "Cherry Grog") then
-- Don't buy Cherry Grog for players that can't drink it.
						else
							if (areWeBuying) then
								local itemLink = GetMerchantItemLink(merch);
								math.randomseed(math.random(0,2147483647)+(GetTime()*1000));
								local buyNum = math.random(5);
								ALE_Emote("buy");
								ALE_Verbose("Purchasing " .. itemLink .. "x" .. buyNum);
								BuyMerchantItem(merch,buyNum);
								areWeBuying = false;
							end
						end
					end
				end
			end
		end
	end
end

function ALE_checkDruid()
-- returns true if you're a druid in shapeshift form, delays drinking.
	local checkForm = false;
	for j = 1, GetNumShapeshiftForms() do
		local _,formName,formActive,_ = GetShapeshiftFormInfo(j);
		if (formActive) then
			if (formName == "Bear Form" or formName == "Cat Form" or formName == "Moonkin Form" or formName == "Dire Bear Form" or formName == "Travel Form") then
				checkForm = true;
				ALE_Verbose("Can't drink in " .. formName .. ", drink will be queued.");
			end
		end
	end
	return checkForm;
end

function ALE_LushDeathDetect()
	local _, _, theDead = string.find(arg1, "(%w+) dies.");
	if (theDead == UnitName("pet")) then
		ALE_LushRealEvent("PetDeath");
	end
	local _,haveTarget = UnitClass("target");
	TargetByName(theDead, true);
	local _,class = UnitClass("target");
	if (class == "HUNTER") then
		for j = 0, 15 do
			local texture = UnitBuff("target", j );
			if ( texture == "Interface\\Icons\\Ability_Rogue_FeignDeath" ) then
				ALE_Verbose(theDead .. " has feigned death. Lag probably made you think it was real. 1 drink added to queue.");
				ALE_QueueDrink = ALE_QueueDrink + 1;
			end
		end
	end
	if (haveTarget ~= nil) then
		TargetUnit("playertarget");
	else
		ClearTarget();
	end
end

function ALE_LushRandom()
end

function ALE_DrinkElapsed()
	if (ALE_DrinkTime + 270 <= time()) then
		if (ALE_Settings.threshold >= 4 and ALE_QueueDrink <= 5) then
			ALE_Verbose("Added another drink to the queue. No excuse needed, just plain thirsty.");
			ALE_QueueDrink = ALE_QueueDrink + 1;
		end
		ALE_DrinkTime = time();
	end
end

function ALE_Sing()
	if (ALE_Singing == 1) then
		ALE_Song = math.random(getn(ALE_DRINK_SONGS));
		SendChatMessage("begins singing a rendition of " .. ALE_DRINK_SONGS[ALE_Song].song,"EMOTE");
	elseif (ALE_Singing == 4) then
		SendChatMessage(ALE_DRINK_SONGS[ALE_Song].line1,"SAY");
	elseif (ALE_Singing == 7) then
		SendChatMessage(ALE_DRINK_SONGS[ALE_Song].line2,"SAY");
	elseif (ALE_Singing == 15) then
		SendChatMessage(ALE_DRINK_SONGS[ALE_Song].line3,"SAY");
	elseif (ALE_Singing == 19) then
		SendChatMessage(ALE_DRINK_SONGS[ALE_Song].line4,"SAY");
	end
	if (ALE_Singing < 20) then
		ALE_Singing = ALE_Singing + 1;
	else
		ALE_Singing = 0;
	end
end

function ALE_Emote(arg)
	if (ALE_Settings.drinking and ALE_Settings.emotes) then
		ALE_MoodChange();
		math.randomseed(math.random(0,2147483647)+(GetTime()*1000));
		local rand = math.random(5);
		if (arg == "buy") then
			rand = math.random(4);
			if (rand == 1) then
				SendChatMessage("slaps down some coin for a drink.","EMOTE");
			elseif (rand == 2) then
				SendChatMessage("eagerly purchases some fine spirits.","EMOTE");
			elseif (rand == 3) then
				SendChatMessage("tosses a coin and decides heads for buying a drink and tails for buying another.","EMOTE");
			else
				SendChatMessage("can't resist buying another drink.","EMOTE");
			end
		elseif (arg == "lush") then
			if (math.random(18) <= 2) then
				rand = math.random(7);
				if (rand == 1) then DoEmote("DROOL",UnitName("player")); elseif (rand == 2) then DoEmote("SCRATCH",UnitName("player")); elseif (rand == 3) then DoEmote("EYE",UnitName("player"));
				elseif (rand == 4) then DoEmote("SMIRK"); elseif (rand == 5) then DoEmote("SHAKE"); elseif (rand == 6) then DoEmote("POKE",UnitName("player"));
				else
					DoEmote("TRAIN");
				end
			elseif (ALE_Mood == "Sad") then
				rand = math.random(10);
				if (rand == 1) then DoEmote("HUG",UnitName("player")); elseif (rand == 2) then DoEmote("FIDGET",UnitName("player")); elseif (rand == 3) then DoEmote("APOLOGIZE",UnitName("player"));
				elseif (rand == 4) then DoEmote("LOST",UnitName("player")); elseif (rand == 5) then DoEmote("PUZZLED",UnitName("player")); elseif (rand == 6) then DoEmote("SHY",UnitName("player"));
				elseif (rand == 7) then DoEmote("TALK",UnitName("player")); elseif (rand == 8) then DoEmote("SIGH",UnitName("player")); elseif (rand == 9) then DoEmote("SOOTHE",UnitName("player"));
				else
					DoEmote("SAD",UnitName("player"));
				end
			elseif (ALE_Mood == "Scared") then
				rand = math.random(9);
				if (rand == 1) then DoEmote("FLEE"); elseif (rand == 2) then DoEmote("FLOP"); elseif (rand == 3) then DoEmote("CONFUSED",UnitName("player"));
				elseif (rand == 4) then DoEmote("PANIC"); elseif (rand == 5) then DoEmote("GROVEL",UnitName("player")); elseif (rand == 6) then DoEmote("PRAY",UnitName("player"));
				elseif (rand == 7) then DoEmote("SURRENDER",UnitName("player")); elseif (rand == 8) then DoEmote("SHIVER");
				else
					DoEmote("SCARED");
				end
			elseif (ALE_Mood == "Obnoxious") then
				rand = math.random(12);
				if (rand == 1) then DoEmote("BONK"); elseif (rand == 2) then DoEmote("BARK"); elseif (rand == 3) then DoEmote("BITE");
				elseif (rand == 4) then DoEmote("INSULT"); elseif (rand == 5) then DoEmote("CRACK"); elseif (rand == 6) then DoEmote("BURP",UnitName("player"));
				elseif (rand == 7) then DoEmote("GUFFAW"); elseif (rand == 8) then DoEmote("NOSEPICK"); elseif (rand == 9) then DoEmote("REAR");
				elseif (rand == 10) then DoEmote("SEXY",UnitName("player")); elseif (rand == 11) then DoEmote("FLEX");
				else
					DoEmote("TAUNT",UnitName("player"));
				end
			elseif (ALE_Mood == "Luvy") then
				rand = math.random(12);
				if (rand == 1) then DoEmote("HUG"); elseif (rand == 2) then DoEmote("KISS"); elseif (rand == 3) then DoEmote("CUDDLE");
				elseif (rand == 4) then DoEmote("CURTSEY"); elseif (rand == 5) then DoEmote("APPLAUD"); elseif (rand == 6) then DoEmote("GREET");
				elseif (rand == 7) then DoEmote("LAUGH",UnitName("player")); elseif (rand == 8) then DoEmote("PRAISE"); elseif (rand == 9) then DoEmote("HAPPY",UnitName("player"));
				elseif (rand == 10) then DoEmote("SEXY"); elseif (rand == 11) then DoEmote("TICKLE",UnitName("player"));
				else
					DoEmote("LOVE");
				end
			end
		elseif (arg == "drink") then
			rand = math.random(100);
			if (rand >= 35 and rand <= 60) then
				rand = math.random(8);
				if (rand == 1) then
					SendChatMessage("discreetly takes a nip from a small flask.","EMOTE");
				elseif (rand == 2) then
					SendChatMessage("chugs one down.","EMOTE");
				elseif (rand == 3) then
					SendChatMessage("sips another drink.","EMOTE");
				elseif (rand == 4) then
					SendChatMessage("honors the God of intoxication by taking another drink.","EMOTE");
				else
					DoEmote("DRINK");
				end
			end
		end
	end
end

function ALE_MoodChange()
	local mood = floor(((date("%d")/10) + date("%I")) / 1.8);
	if (mood == 0 or mood == 3) then
		mood = "Sad";
	elseif (mood == 1 or mood == 4) then
		mood = "Scared";
	elseif (mood == 2 or mood == 5) then
		mood = "Obnoxious";
	else
		mood = "Luvy";
	end
	if (ALE_Settings.roleplay) then
		if ((ALE_Mood == nil or ALE_Mood ~= mood) and ALE_Settings.emotes and ALE_Defcon >= 2) then
			ALE_Verbose("Drunken mood: " .. mood .. ".");
		end
	end
	ALE_Mood = mood;
end

function ALE_LushSpecialEvents()
	math.randomseed(math.random(0,2147483647)+(GetTime()*1000));
	if (ALE_LushEvent == "Smashed") then
		if (math.random(100) <= 30) then
			DoEmote("sleep");
		end
	elseif (ALE_LushEvent == "Drunk") then
		if (math.random(100) <= 8) then
			DoEmote("sleep");
		end
	elseif (ALE_LushEvent == "OptionsClosed") then
		ALE_Message("Warning - \"Lush\" + \"Roleplay\" mode may cause your character to do things which you may find detrimental. IE: Your character may purchase drinks at vendors, randomly fall asleep and other drunken disorderly conduct.");
	elseif (ALE_LushEvent == "DrinkConfirmed") then
-- random drink emotes? Fix this stuff
	elseif (ALE_LushEvent == "") then
	elseif (ALE_LushEvent == "") then
	elseif (ALE_LushEvent == "") then
	end
	ALE_LushEvent = "";
end

function ALE_LushRealEvent(arg)
	if (arg  == "NPCYell") then
		ALE_Verbose("An NPC yelled. You probably missed it due to lag. 1 drink added to queue.");
	elseif (arg == "NPCRun") then
		ALE_Verbose("A mob is running away. You probably won't catch them due to lag. 1 drink added to queue.");
	elseif (arg == "DuelStart") then
		ALE_Verbose("You're about to duel but lag will probably cause a slow start for you. 1 drink added to queue.");
	elseif (arg == "DuelLost") then
		ALE_Verbose("You lost a duel. Blame it on lag. 1 drink added to queue.");
	elseif (arg == "PetDeath") then
		ALE_Verbose("You're pet has died. Oh Noes! Must have been lag. 1 drink added to queue.");
	elseif (arg == "Dead") then
		ALE_Verbose("You've died. Lagged to death? 1 drink added to queue.");
	elseif (arg == "ManaGone") then
		ALE_Verbose("Cast failed due to lag of mana. You probably didn't notice due to lag. 1 drink added to queue.");
	end
	ALE_QueueDrink = ALE_QueueDrink + 1;
end

function ALE_LushDefcon()
	if (arg1 == DRUNK_MESSAGE_SELF1) then
		ALE_Defcon = 0; -- Sober
	elseif (arg1 == DRUNK_MESSAGE_SELF2) then
		ALE_Defcon = 1; -- Tipsy
	elseif (arg1 == DRUNK_MESSAGE_SELF3) then
		ALE_Defcon = 2; -- Drunk
		ALE_MoodChange();
		ALE_LushEvent = "Drunk";
	elseif (arg1 == DRUNK_MESSAGE_SELF4) then
		ALE_Defcon = 3; -- Smashed
		ALE_LogoText:SetText("Smashed!");
		if (ALE_ResetGraph < 1) then
			ALE_ResetGraph = 1;
		end
		ALE_LushEvent = "Smashed";
	elseif (ALE_Settings.drinking and ALE_Settings.threshold == 5) then
-- checks for Lush events
		if (arg1 == "Duel starting: 2") then
			ALE_LushRealEvent("DuelStart");
		elseif (string.find(arg1, "in a duel")) then
			local _, _, duelerWon, duelerLost = string.find(arg1, "(%w+) has defeated (%w+) in a duel");
--			ALE_Verbose("Duel: " .. duelerWon .. " defeated " .. duelerLost);
			if (duelerLost == UnitName("player")) then
				ALE_LushRealEvent("DuelLost");
			end
		end
	end
end
