
function ALE_Options_Initialize()
	ALE_LogoOptionsTwo:SetTextHeight(14);
	ALE_LogoOptionsThree:SetTextHeight(10);
	ALE_LogoOptionsThree:SetText(ALE_Settings.version);
end

function ALE_Options_Toggle()
	if (ALE_OptionsWindow:IsVisible()) then
		ALE_OptionsWindow:Hide();
	else
		ALE_OptionsWindow:Show();
	end
end

function ALE_ScaleSlider_Init(slider)
    local sl = getglobal(slider);
	sl.tooltipText = "Scale Graph Window"; 
	getglobal(slider .. "Low"):SetText("60%");
	getglobal(slider .. "High"):SetText("200%"); 
	getglobal(slider .. "Text"):SetText("100%");
	getglobal(slider):SetValue(ALE_Settings.GraphScale);
end

function ALE_ScaleSlider_Move(slider)
	if (ALE_Settings ~= nil) then
		getglobal(this:GetName().."Text"):SetText(this:GetValue() .. "%");
		if this:GetValue() ~= ALE_Settings.GraphScale then
			ALE_Settings.GraphCenterx, ALE_Settings.GraphCentery = ALE_GraphWindow:GetCenter();
			ALE_Settings.GraphCenterx = ALE_Settings.GraphCenterx * (ALE_Settings.GraphScale / 100);
			ALE_Settings.GraphCentery = ALE_Settings.GraphCentery * (ALE_Settings.GraphScale / 100);
			ALE_GraphWindow:ClearAllPoints();
			local Scalesize = this:GetValue() / 100;
			ALE_Settings.GraphScale = getglobal(this:GetName()):GetValue();
			ALE_GraphWindow:ClearAllPoints();
			ALE_GraphWindow:SetPoint("CENTER", "UIParent", "BOTTOMLEFT",ALE_Settings.GraphCenterx / Scalesize, ALE_Settings.GraphCentery / Scalesize);
			ALE_GraphWindow:SetScale(Scalesize);
		end
	end
end

function ALE_ThresholdSlider_Init(slider)
	this.tooltipText = "How much you'll drink";
	getglobal("ALE_ThresholdSliderLow"):SetText("Casual");
	getglobal("ALE_ThresholdSliderHigh"):SetText("Lush"); 
	if (ALE_Settings ~= nil) then
		if (ALE_Settings.threshold == 1) then
			getglobal("ALE_ThresholdSliderText"):SetText("Casual Drinker");
		elseif (ALE_Settings.threshold == 2) then
			getglobal("ALE_ThresholdSliderText"):SetText("Wearing Beerglasses");
		elseif (ALE_Settings.threshold == 3) then
			getglobal("ALE_ThresholdSliderText"):SetText("Shotgunning");
		elseif (ALE_Settings.threshold == 4) then
			getglobal("ALE_ThresholdSliderText"):SetText("Squeanhead");
		elseif (ALE_Settings.threshold == 5) then
			getglobal("ALE_ThresholdSliderText"):SetText("Lush");
		else
			getglobal("ALE_ThresholdSliderText"):SetText("Shotgunning");
		end
		if (ALE_Settings.threshold ~= nil) then
			getglobal(slider):SetValue(ALE_Settings.threshold);
		end
		if (ALE_Settings.drinking) then
			ALE_DrinkingCheckbox:SetChecked(true);
		else
			ALE_SoundsComment:SetTextColor(1,0.82,0,0.5);
			ALE_EmotesComment:SetTextColor(1,0.82,0,0.5);
			ALE_RoleplayComment:SetTextColor(1,0.82,0,0.5);
			ALE_VerboseComment:SetTextColor(1,0.82,0,0.5);
		end
		if (ALE_Settings.sounds) then
			ALE_SoundsCheckbox:SetChecked(true);
		end
		if (ALE_Settings.emotes) then
			ALE_EmotesCheckbox:SetChecked(true);
		end
		if (ALE_Settings.roleplay) then
			ALE_RoleplayCheckbox:SetChecked(true);
		end
		if (ALE_Settings.verbose) then
			ALE_VerboseCheckbox:SetChecked(true);
		end
	else
		getglobal("ALE_ThresholdSliderText"):SetText("Threshold");
	end
end

function ALE_ThresholdSlider_Move(slider)
	if (ALE_Settings ~= nil) then
		if (this:GetValue() == 1) then
			getglobal(this:GetName().."Text"):SetText("Casual Drinker");
			table.sort(ALE_DRINK_LIST, ALE_sortfunc_SortValue);
		elseif (this:GetValue() == 2) then
			getglobal(this:GetName().."Text"):SetText("Wearing Beerglasses");
			table.sort(ALE_DRINK_LIST, ALE_sortfunc_SortValue);
		elseif (this:GetValue() == 3) then
			getglobal(this:GetName().."Text"):SetText("Shotgunning");
			table.sort(ALE_DRINK_LIST, ALE_sortfunc_SortValue);
			if (ALE_Settings.threshold == 4 and ALE_Settings.roleplay) then
				ALE_Message("Sorting drinks by value...");
			end
		elseif (this:GetValue() == 4) then
			getglobal(this:GetName().."Text"):SetText("Squeanhead");
			table.sort(ALE_DRINK_LIST, ALE_sortfunc_SortPotency);
			if (ALE_Settings.threshold == 3 and ALE_Settings.roleplay) then
				ALE_Message("Sorting drinks by potency...");
			end
		elseif (this:GetValue() == 5) then
			getglobal(this:GetName().."Text"):SetText("Lush");
			table.sort(ALE_DRINK_LIST, ALE_sortfunc_SortPotency);
		end
		ALE_Settings.threshold = this:GetValue();
	end
end

function ALE_GenericCheckbox_OnClick(setting)
	if (setting == "drinking") then
		if (this:GetChecked()) then
			ALE_Settings.drinking = true;
			ALE_SoundsComment:SetTextColor(1,0.82,0,1);
			ALE_EmotesComment:SetTextColor(1,0.82,0,1);
			ALE_RoleplayComment:SetTextColor(1,0.82,0,1);
			ALE_VerboseComment:SetTextColor(1,0.82,0,1);
		else
			ALE_Settings.drinking = false;
			ALE_SoundsComment:SetTextColor(1,0.82,0,0.5);
			ALE_EmotesComment:SetTextColor(1,0.82,0,0.5);
			ALE_RoleplayComment:SetTextColor(1,0.82,0,0.5);
			ALE_VerboseComment:SetTextColor(1,0.82,0,0.5);
		end
	else
		if (ALE_Settings.drinking) then
			if (setting == "sounds") then
				if (this:GetChecked()) then
					ALE_Settings.sounds = true;
				else
					ALE_Settings.sounds = false;
				end
			elseif (setting == "emotes") then
				if (this:GetChecked()) then
					ALE_Settings.emotes = true;
				else
					ALE_Settings.emotes = false;
				end
			elseif (setting == "roleplay") then
				if (this:GetChecked()) then
					ALE_Settings.roleplay = true;
					ALE_Message("Note - The Roleplay option will cause you to automatically consume in-game alcoholic beverages found in your bags. If you value these items, turn this option off. For a list of drinks type /drinklist");
				else
					ALE_Settings.roleplay = false;
				end
			elseif (setting == "verbose") then
				if (this:GetChecked()) then
					ALE_Settings.verbose = true;
				else
					ALE_Settings.verbose = false;
				end
			end
		else
			if (this:GetChecked()) then
				this:SetChecked(false);
			else
				this:SetChecked(true);
			end
		end
	end
end

function ALE_OptionsClose()
	ALE_LushEvent = "OptionsClosed";
end

